package me.akito123321.valoStrats.schemas;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import jakarta.persistence.CascadeType;
import jakarta.persistence.ElementCollection;
import jakarta.persistence.Entity;
import jakarta.persistence.FetchType;
import jakarta.persistence.GeneratedValue;
import jakarta.persistence.GenerationType;
import jakarta.persistence.Id;
import jakarta.persistence.ManyToMany;
import jakarta.persistence.ManyToOne;
import jakarta.persistence.OneToMany;

@Entity(name = "strats_group")
public class Group {
	@Id
	@GeneratedValue(strategy = GenerationType.UUID)
	private String id;
	private String name;
	@ManyToOne
	private StratsUser owner;
	@ManyToMany(fetch = FetchType.EAGER)
	private List<StratsUser> members = new ArrayList<StratsUser>();
	@OneToMany(fetch = FetchType.EAGER, cascade = CascadeType.ALL, mappedBy = "group")
	private List<Strat> strats = new ArrayList<Strat>();

	@OneToMany(fetch = FetchType.EAGER, cascade = CascadeType.ALL, mappedBy = "group")
	private List<Map> maps = new ArrayList<Map>();

	@OneToMany(fetch = FetchType.EAGER, cascade = CascadeType.ALL, mappedBy = "group")
	private List<Profile> profiles = new ArrayList<Profile>();
	
	@ElementCollection(fetch = FetchType.EAGER)
	private Set<String> stratTypes = new HashSet<String>();

	public Group(String name, StratsUser owner) {
		this.name = name;
		this.owner = owner;
	}

	public Group() {

	}

	public String getId() {
		return id;
	}

	public String getName() {
		return name;
	}

	public StratsUser getOwner() {
		return owner;
	}

	public List<StratsUser> getMembers() {
		return members;
	}

	public List<Strat> getStrats() {
		return strats;
	}

	public void setName(String name) {
		this.name = name;
	}

	public Set<String> getStratTypes() {
		return stratTypes;
	}

	public List<Map> getMaps() {
		return maps;
	}

	public List<Profile> getProfiles() {
		return profiles;
	}

}
